package labyrinth;

import java.awt.Point;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Labyrinth {
	
	private byte[][] matrix;
	
	private int x;
	private int y;
	
	private Point startingPoint;
	private Point endingPoint;

	
	
	private Labyrinth(byte[][] matrix, int width, int length,
			Point startingPoint, Point endingPoint) {
		super();
		this.matrix = matrix;
		this.x = width;
		this.y = length;
		this.startingPoint = startingPoint;
		this.endingPoint = endingPoint;
	}
	public byte[][] getMatrix() {
		return matrix;
	}
	public int getX() {
		return x;
	}
	public int getY() {
		return y;
	}
	public Point getStartingPoint() {
		return startingPoint;
	}
	public Point getEndingPoint() {
		return endingPoint;
	}
	public int getValue(Point p){
		return matrix[p.x][p.y];
	}
	public int getValue(int x, int y){
		return matrix[x][y];
	}
	
	public static Labyrinth loadLabyrinth(String filePath){

			Scanner scanner;
			Point startingPoint = null;
			Point endingPoint = null;
			byte[][] matrix = null;
			int length = 0;
			int width = 0;
			try {
				scanner = new Scanner(new File(filePath));
				startingPoint = new Point(scanner.nextInt(), scanner.nextInt());
				endingPoint = new Point(scanner.nextInt(), scanner.nextInt());
				length = scanner.nextInt();
				width = scanner.nextInt();
				matrix = new byte[length][width];
				for(int i = 0; i<length; i++){
					for(int j = 0; j<width; j++){
						matrix[i][j] = scanner.nextByte();
					}
				}
			
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		
		return new Labyrinth(matrix, width, length, startingPoint, endingPoint);
	};
}
